'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(auth) {
    _classCallCheck(this, _class);

    this.auth = auth;
  }

  _createClass(_class, [{
    key: 'process',
    value: function process(httpRequest, httpResponse, next) {
      if (!httpRequest.headers.authorization) {
        httpResponse.status(401);
        httpResponse.header('WWW-Authenticate', 'Basic realm=\"ap-npm\"');
        httpResponse.send('Unauthorized');
      } else {
        var userLogin = new Buffer.from(httpRequest.headers.authorization.substr(6), 'base64').toString('UTF-8');
        var userInfo = userLogin.split(':');
        var username = userInfo[0];
        var password = userInfo[1];

        this.auth.verifyLogin(username, password).then(function (loggedIn) {
          if (loggedIn === true) {
            next();
          } else {
            httpResponse.status(401);
            httpResponse.send("Invalid username and password, unauthorized");
          }
        });
      }
    }
  }]);

  return _class;
}();

exports.default = _class;