'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(auth) {
    _classCallCheck(this, _class);

    this.auth = auth;
  }

  _createClass(_class, [{
    key: 'process',
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var token = httpRequest.headers.authorization.substr(7);
        var user = _this.auth.verifyToken(token);

        if (user !== false) {
          httpResponse.send({
            username: user
          });
          resolve();
        } else {
          reject();
        }
      }).catch(function () {
        httpResponse.status(401);
        httpResponse.send('Invalid user');
      });
    }
  }]);

  return _class;
}();

exports.default = _class;