"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage, validator) {
    _classCallCheck(this, _class);

    this.storage = storage;
    this.packageValidator = validator;
  }

  /*
   * Reads dist-tags and sends them to npm-client
   * *** hasn't been tested yet***
   */


  _createClass(_class, [{
    key: "process",
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var packageName = httpRequest.body._packageName;
        var packageScope = httpRequest.body._scope;
        var distTag = httpRequest.params.tag;
        var distTagVersion = httpRequest.body;

        _this.storage.getPackageJson({
          name: packageName,
          scope: packageScope
        }).then(function (packageJson) {
          if (_typeof(packageJson.versions[distTagVersion]) !== "object") {
            reject("403, version does not exist");
          }

          packageJson['dist-tags'][distTag] = distTagVersion;

          _this.storage.updatePackageJson({
            name: packageName,
            scope: packageScope
          }, packageJson).then(function (result) {
            if (result === true) {
              httpResponse.status(200);
              httpResponse.send({
                ok: "dist-tags added"
              });
              resolve();
            } else {
              reject("404, could not get dist-tags");
            }
          });
        });
      }).catch(function (err) {
        httpResponse.status(404);
        httpResponse.send(err);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;