'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _safe = require('colors/safe');

var _safe2 = _interopRequireDefault(_safe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class() {
    _classCallCheck(this, _class);

    _safe2.default.setTheme({
      log: 'black',
      info: 'green',
      warn: 'yellow',
      error: 'red',
      debug: 'blue'
    });
  }

  _createClass(_class, [{
    key: 'routerLogger',
    value: function routerLogger(req, res, next) {
      console.log("\nMETHOD:", req.method, ", URL:", decodeURIComponent(req.originalUrl));
      next();
    }
  }, {
    key: 'log',
    value: function log(message) {
      console.log(_safe2.default.log(message));
    }
  }, {
    key: 'info',
    value: function info(message) {
      console.info(_safe2.default.info(message));
    }
  }, {
    key: 'warn',
    value: function warn(message) {
      console.warn(_safe2.default.warn(message));
    }
  }, {
    key: 'error',
    value: function error(message) {
      console.error(_safe2.default.error(message));
    }
  }, {
    key: 'debug',
    value: function debug(message) {
      console.debug(_safe2.default.debug(message));
    }
  }]);

  return _class;
}();

exports.default = _class;