'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _https = require('https');

var _https2 = _interopRequireDefault(_https);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(proxyUrl) {
    _classCallCheck(this, _class);

    this.proxyUrl = proxyUrl;
  }

  _createClass(_class, [{
    key: 'process',
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function () {
        var pkgData = httpRequest.body;
        var urlPath = void 0;

        if (pkgData._scopedName) {
          urlPath = pkgData._scopedName;
        } else {
          urlPath = '/' + pkgData._packageName;
        }

        var url = _this.proxyUrl + urlPath;
        _https2.default.get(url, function (response) {
          response.pipe(httpResponse);
        });
      }).catch(function (err) {
        httpResponse.status(500);
        httpResponse.send(err);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;