'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _httpolyglot = require('httpolyglot');

var _httpolyglot2 = _interopRequireDefault(_httpolyglot);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(server, config) {
    _classCallCheck(this, _class);

    this.app = server;
    this.port = config.port;
    this.ssl = config.ssl;
    this.hostname = config.hostname;
    this.config = config;
  }

  _createClass(_class, [{
    key: 'run',
    value: function run() {
      var _this = this;

      if (this.ssl.enabled) {
        if (_fs2.default.existsSync(this.ssl.key) && _fs2.default.existsSync(this.ssl.cert)) {
          var key = _fs2.default.readFileSync(this.ssl.key);
          var cert = _fs2.default.readFileSync(this.ssl.cert);

          _httpolyglot2.default.createServer({
            key: key,
            cert: cert
          }, this.app).listen(this.port, this.hostname, function () {
            console.log("ap-npm is listening on" + _this.hostname + ":" + _this.port + '\n');
          });
        } else {
          this.config.ssl.enabled = false;
          console.log("ssl setup failed, key/cert files don't exist\n" + "ap-npm will run without being accessible using ssl\n");

          console.log("ap-npm is listening on http://" + this.hostname + ":" + this.port + '\n');
          this.app.listen(this.port);
        }
      } else {
        console.log("ap-npm is listening on http://" + this.hostname + ":" + this.port + '\n');
        this.app.listen(this.port);
      }
    }
  }]);

  return _class;
}();

exports.default = _class;