'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (container) {
  container.set('command-serve', function () {
    var Command = require('../commands/serve').default;
    return new Command(container.get('express'), container.get('config'));
  });

  container.set('command-init', function () {
    var Command = require('../commands/init').default;
    var config = container.get('config');
    return new Command(config.hostname, config.port, config.ssl.enabled);
  });

  container.set('command-config', function () {
    var Command = require('../commands/config').default;
    return new Command();
  });
};