"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage, validator) {
    _classCallCheck(this, _class);

    this.storage = storage;
    this.packageValidator = validator;
  }

  _createClass(_class, [{
    key: "process",
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var packageName = httpRequest.params.package;
        var distTag = httpRequest.params.tag;

        _this.storage.getPackageJson({
          name: httpRequest.params.package
        }).then(function (packageJson) {
          delete packageJson['dist-tags'][distTag];

          _this.storage.updatePackageJson({
            name: packageName
          }, packageJson).then(function (result) {
            if (result === true) {
              httpResponse.status(200);
              resolve(httpResponse.send({
                ok: "dist-tags updated"
              }));
            } else {
              reject("404, could not get dist-tags");
            }
          });
        });
      }).catch(function (err) {
        httpResponse.send(err);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;