'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (request, storageLocation) {
  var packageName = request.name;
  var packageScope = request.scope;
  var fileName = request.file;

  return new Promise(function (resolve) {
    var fileLocation = void 0;

    if (packageScope) {
      fileLocation = _path2.default.join(storageLocation, packageScope, packageName, fileName);
    } else {
      fileLocation = _path2.default.join(storageLocation, packageName, fileName);
    }

    resolve(_fs2.default.readFileSync(fileLocation));
  });
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }